// Modified version for PP01
#include <stdio.h>
#include <stdlib.h>

int main(int argc, char *argv[]) {
    if (argc != 3) {
        printf("Usage: %s <input_file> <output_file>\n", argv[0]);
        return 1;
    }

    char *input_file = argv[1];
    char *output_file = argv[2];
    unsigned int width = 256;		// atoi(argv[3]);
    unsigned int height;

    // Open the input file
    FILE *in = fopen(input_file, "rb");
    if (!in) {
        printf("Error: Failed to open input file\n");
        return 1;
    }

    // Calculate the height based on the file size and width
    fseek(in, 0L, SEEK_END);
    long file_size = ftell(in);
    fseek(in, 0L, SEEK_SET);
    //height = file_size / width;
	height = 256;

    // Open the output file
    FILE *out = fopen(output_file, "wb");
    if (!out) {
        printf("Error: Failed to open output file\n");
        fclose(in);
        return 1;
    }

    // Color iterations
    //unsigned char mask = 2;
    unsigned int pos = 0;
	//unsigned int cnt = 0;
	
  	for (int y = 0; y < height; y++) {
		for (int c = 0; c < 3; c++ ) {
    // Loop over each pixel in the input file, convert to RGB, and write to output file
        	for (int x = 0; x < (width/8); x++) {
                	unsigned int offset = 0;
					unsigned char outb = 0;
                	//for(int z = 0; z < 8; z++ )  {
                        	unsigned char pixel;
							if ( c == 0 ) offset = 8192;
							if ( c == 1 ) offset = 0;
							if ( c == 2 ) offset = 16384;
							
							pos=offset+x+32*y;
							
							fseek(in,pos,SEEK_SET);
                        	fread(&pixel, 1, 1, in);
                        	outb = pixel;
							//printf ("Pos: %d \r",cnt);
							//cnt++;
							//outb <<= 1;
                        	//if ( (pixel[0] & mask) == mask ) outb++;
                        //}
                	fprintf(out, "%c", outb);
        	}
    	}
		for (int z=0; z < 32; z++) {
			fprintf(out,"%c",0);
		}
	}
/*		
	if ( mask == 2 ) {
			mask = 4; 
		} else {
			mask = 1;
		}
    	fseek(in,0,SEEK_SET);
    }
*/
    // Close files and exit
    fclose(in);
    fclose(out);
    return 0;
}
